Subject: Re: "Message Capsule" Proposal

From: [email-masked] (Tom Henderson)
Date: Tue, 19 Jan 93 11:03:13 MST

Tony Skjellum pointed out that Zipcode has been successfully using "invoices" 
that work in the same way as "capsules" for several years.  Tony's comments 
were not sent to the entire mailing list and are repeated below, with his 
permission:  

> Please read about our message packing in the following uuencoded,
> compressed postscript file.  We already have created this technology.
> 
(we've omitted the postscript file)
> 
> We are able to deal effectively with fortran packing and unpacking
> of messages, and 'pack+send' and 'unpack+receive' are inherently
> more optimizable on some systems.
> 
> - Tony

Chuck Simmons points out that:  

> ...
> Standards bodies work best when they standardize existing work, and work 
> worst when they attempt to design.  
> ...
> 
> Cheers, Chuck Simmons

We think that the success of "invoices" in Zipcode supports the argument that 
the "Message Capsule" proposal is an attempt to standardize existing work.  
(BTW, we aren't really that satisfied with the term "capsule".  Another term 
may be better.)  

Tom Henderson                       Leslie Hart
[email-masked]                 [email-masked]

---

From: [email-masked] (Tom Henderson)
Date: Tue, 19 Jan 93 11:11:50 MST

The following is excerpts from an email discussion we have been having with 
Tony Skjellum regarding message "capsules" or "invoices".  We have forwarded 
it with Tony's permission.  Our comments are marked with ">>" and Tony's are 
marked with ">".  

> 
> Please pass along my comments.  Invoices are important, in that they
> permit additional possible optimizations.  The more the user says
> "what" and not "how," to accomplish transfer, the more opportunity for
> faster performance.  Invoices make Fortran-based message passing much
> nicer, as well as providing more sophisticated packing/unpacking for C
> people.
> 

>> Several people (including us) were uneasy with the "hidden state" associated 
>> with stack-based context management.  Any particular reason for using stacks 
>> in Zipcode?  

> Stacks are a detail of conext handling.  They are not essential.
> - Tony